// $Id: class_CompanionDisplayer.js,v 1.21 2005/12/15 04:02:26 bkennelly Exp $

// the edit box object probably should be in a different file
// but currently it has no properties, and is just a placeholder
function EditBox(width)
{
	this.width = width;
}
function Label()
{
}

function CompanionDisplayer(preferences)
{
    this.preferences = preferences;
    this.toolBarId = null;
    this.itemIdx = 0;
    this.imgMap = new ImageResolver();
    this.UseIconsAndNames = true;
    this.AlertButtonId = "";
    this.charset = "iso-8859-1";
}

// set the reference to the toolbar container.. this is an element
// from the browser, as from:
// document.getElementById(myToolbarId)
CompanionDisplayer.prototype.setToolBarId = function(tb)
{
    this.toolBarId = tb;
}

// now we actually display the items.
// this is really a 2 step process...
// 1. build up a new toolbox element...
// 2. append it to the this.toolbar
// 3. hide the static toolbar
// 4. display the dynamic toolbar.
CompanionDisplayer.prototype.display = function(items)
{
    var dynamicToolBar = new Array();
    
    // now build all the elements from the items array
    var i = 0;
    for( ; i < items.length ; i++)
    {
        var it = null;
        if(items[i].constructor == Button)
        {
            it = this.buildButton(items[i]);
        }
        else if(items[i].constructor == ButtonMenu)
        {
            it = this.buildButtonMenu(items[i]);
        }
        else if(items[i].constructor == Menu)
        {
            it = this.buildMenu(items[i], false);
        }
        else if(items[i].constructor == EditBox)
        {
            it = this.buildEditBox(items[i]);
        }
        else if(items[i].constructor == Label)
        {
            it = this.buildLabel(items[i]);
        }
        else
        {
            alert("Don't know how to add a " + items[i].constructor);
        }
        if(it != null)
            dynamicToolBar.push(it);
    }    
    
    var buttonBox = document.createElement("hbox");
    buttonBox.flex = 1;
    

    for(var p=0 ; p < dynamicToolBar.length; p++)
    {
        dynamicToolBar[p].setAttribute("collapsed","false");
        dynamicToolBar[p].setAttribute("inherits","hidden");
        buttonBox.appendChild(dynamicToolBar[p]);
    }
    
    
    
    // first we see if we already have a toolbar.
    // if so, then hide everything in it, and add these new elements.
    var dynToolBar;
    dynToolBar = document.getElementById('yahootoolbar_dyn');
    if(dynToolBar == null)
    {
        //alert("Creating new dynamic toolbar");
        dynToolBar = document.createElement("toolbar");
        dynToolBar.setAttribute("id","yahootoolbar_dyn");
        dynToolBar.setAttribute("grippytooltiptext","Yahoo! Toolbar");
        var mainBox = document.getElementById('navigator-toolbox');
     	mainBox.appendChild(dynToolBar);
    }
    else
    {
        //alert("replacing existing toolbar.");
        // hide everything under it
        
        // now actually remove the toolbar, not just hiding it.
        while (dynToolBar.hasChildNodes())
            dynToolBar.removeChild(dynToolBar.firstChild);
        
        /* this was the code to hide it
        var tmp = dynToolBar.childNodes;
        for(var q=0; q < tmp.length; q++)
        {
            tmp[q].setAttribute("hidden","true");
        }
        */
    }
    
    dynToolBar.appendChild(buttonBox);

    this.doBookmarkModifications();
 }

CompanionDisplayer.prototype.doBookmarkModifications = function()
{
    
    // modify "add/edit" link and add import and export links
    if (this.preferences.addImportExportLinks) {
        this.addImportExportLinks();
    }

    // build bookmark toolbar buttons
    if (this.preferences.quickLaunchOn) {
        this.buildBookmarkToolbarButtons();
    }

    // hide the browser's main bookmark menu

    var browserBookmarksMenu = document.getElementById("bookmarks-menu") ||          // Firefox
           document.getElementById("BookmarksMenu") ;            // Netscape
    if (browserBookmarksMenu)
    {
    	if (this.preferences.hideBrowserBookmarksMenu) {
       	    browserBookmarksMenu.hidden=true;
    	} else 
	    browserBookmarksMenu.hidden=false;
    }

    // hide the yahoo bookmark menu
    var yahooToolbarBookmarks = document.getElementById("yahooToolbarBookmarks").parentNode;
    if (yahooToolbarBookmarks)
    {
        if (this.preferences.hideYahooBookmarksMenu) {
       	       yahooToolbarBookmarks.hidden=true;
        } else
              yahooToolbarBookmarks.hidden=false;
     }

    // create the yahoo bookmarks menu in browser
    if (this.preferences.createYahooBookmarksBrowserMenu) {
        this.buildYahooBookmarksBrowserMenu();
    }
}

CompanionDisplayer.prototype.addImportExportLinks = function()
{
    var menupopup = document.getElementById("yahooToolbarBookmarks");
    var children = menupopup.childNodes; // menupopup's children
    var myStrings = document.getElementById("yahootoolbar_strings");

    // change label from "Add/Edit Bookmarks..." to just "Edit Bookmarks..."
    var txt = myStrings.getString("editBookmarks");
    children[1].setAttribute("label", txt);

    var sep = document.createElement("menuseparator");
    sep.setAttribute("id", "dynbutton" + this.itemIdx);
    this.itemIdx++;

    var link = document.createElement("menuitem");
    link.setAttribute("id", "dynbutton" + this.itemIdx);
    txt = myStrings.getString("importBookmarks");
    link.setAttribute("label", txt);
    link.setAttribute("oncommand", "yahootoolbar.LoadPage('http://e.my.yahoo.com/config/upload_bookmark?.done=http%3a//us.edit.companion.yahoo.com/config/slv4_done%3f.bme=1&.bmprop=&.src=bookmarks'); return true;");
    this.itemIdx++;

    var link2 = document.createElement("menuitem");
    link2.setAttribute("id", "dynbutton" + this.itemIdx);
    txt = myStrings.getString("exportBookmarks");
    link2.setAttribute("label", txt);
    link2.setAttribute("oncommand", "yahootoolbar.LoadPage('http://e.my.yahoo.com/config/export_bookmark?.done=http%3a//us.edit.companion.yahoo.com/config/slv4_done%3f.bme=1&.bmprop=&.src=bookmarks'); return true;");
    this.itemIdx++;

    menupopup.insertBefore(link, children[2]);
    menupopup.insertBefore(link2, children[2]);
    menupopup.insertBefore(sep, children[1]);
} // end addImportExportBookmarks

CompanionDisplayer.prototype.buildYahooBookmarksBrowserMenu = function()
{
    var yahooToolbarBookmarks = document.getElementById("yahooToolbarBookmarks").parentNode;
    var browserBookmarksMenu = document.getElementById("bookmarks-menu") ||    // Firefox
    	                       document.getElementById("BookmarksMenu") ;      // Mozilla
    
    this.removeYahooBrowserBookmarksMenu();

    var yahooBookmarksMenu = document.createElement("menu");
    var txt = document.getElementById("yahootoolbar_strings").getString("yahooBookmarkMenu");
    yahooBookmarksMenu.setAttribute("label", txt);
    yahooBookmarksMenu.setAttribute("accesskey", browserBookmarksMenu.getAttribute("accesskey"));
    yahooBookmarksMenu.setAttribute("id", "yahoo-bookmarks-menu");

    var children = yahooToolbarBookmarks.childNodes;

    for(var x = 0; x < children.length; x++) {
        yahooBookmarksMenu.appendChild(children[x].cloneNode(true));
    }

    browserBookmarksMenu.parentNode.insertBefore(yahooBookmarksMenu, browserBookmarksMenu);
} // end createYahooBookmarksBrowserMenu

CompanionDisplayer.prototype.buildBookmarkToolbarButtons = function()
{
    var yahooToolbar = document.getElementById('yahootoolbar_dyn').firstChild;

    // find the specially marked menu/folder for the toolbar info in the bookmarks list
    var yahooToolbarLaunch = document.getElementById("yahooToolbarLaunch");

    if (yahooToolbarLaunch != null) {
        var yahooToolbarItems = document.getElementById("yahoo-bookmark-toolbar-items");
        if (yahooToolbarItems != null) {
            yahooToolbarItems.parentNode.removeChild(yahooToolbarItems);
        }

        var toolbaritem = document.createElement("toolbaritem");
        toolbaritem.setAttribute("id", "yahoo-bookmark-toolbar-items");

        var menubar = document.createElement("menubar");
        menubar.setAttribute("id", "yahooBookmarksMenubar");
        menubar.setAttribute("style", "border: 0px none ; margin: 0px; padding: 0px; -moz-appearance: none;");
        toolbaritem.appendChild(menubar);

        var bookmarks = yahooToolbarLaunch.firstChild.childNodes;

        // we iterate through the first level of menuitems and menus because they
        // are not the right types for display on the toolbar

        // skip the first item because that's an "add to bookmark" menu item
        for(var i = 1; i < bookmarks.length; i++) {
            if (bookmarks[i].nodeName == "menuitem") {
                var button = document.createElement("toolbarbutton");
                button.setAttribute("class", "yahoobutton");
                button.setAttribute("id", "dynbutton" + this.itemIdx);
                button.setAttribute("label", bookmarks[i].getAttribute("label"));
                button.setAttribute("oncommand", bookmarks[i].getAttribute("oncommand"));
                menubar.appendChild(button);
                this.itemIdx++;
            } else if (bookmarks[i].nodeName == "menu") {
                var menu = document.createElement("toolbarbutton");
                menu.setAttribute("class", "yahoobuttonmenu");
                menu.setAttribute("id", "dynbutton" + this.itemIdx);
                menu.setAttribute("label", bookmarks[i].getAttribute("label"));
                menu.setAttribute("type", "menu");
                menu.setAttribute("collapsed", "false");
                menu.setAttribute("inherits", "hidden");

                // when we create the new menu we want to keep the original children
                // so add them

                var children = bookmarks[i].childNodes;

                for(var j = 0; j < children.length; j++) {
                    menu.appendChild(children[j].cloneNode(true));
                }
                menubar.appendChild(menu);
                this.itemIdx++;
            } else {
                // ignore menuseparator items, we don't want them on the toolbar
            }
        } // end for

        yahooToolbar.appendChild(toolbaritem);

    } // bookmarks != null
} // end buildBookmarkToolbarButtons

// when we uninstall the toolbar we need to make sure to uninstall the
// yahoo browser bookmark menu if we've added it at any time during the 
// lifetime of the toolbar
CompanionDisplayer.prototype.removeYahooBrowserBookmarksMenu = function()
{
    var yahooBrowserBookmarksMenu = document.getElementById("yahoo-bookmarks-menu");
    if (yahooBrowserBookmarksMenu != null) {        
        yahooBrowserBookmarksMenu.parentNode.removeChild(yahooBrowserBookmarksMenu);
    }
}

CompanionDisplayer.prototype.buildEditBox = function(ed)
{
    var dynBox = document.createElement("menulist");
    dynBox.setAttribute("id","yahootoolbarSearchTextDyn");
    dynBox.setAttribute("class","yahootoolbarSearchText");
    dynBox.setAttribute("editable","true");

    // Set the width according to the Yahoo! feed.  
    dynBox.width = ed.width * 9;
    // Set 'sizetopopup' to prevent the popup menu from truncating at the menu width
    dynBox.setAttribute("sizetopopup","no");
    
    dynBox.setAttribute("onkeypress","if(event.keyCode == 13) { yahootoolbar.dynSearch(); } ");
    
    // we need to add any existing search terms
    this.saveOldSearchTerms(dynBox, "yahootoolbarSearchTextDyn");
    //var oldMenuList = document.getElementById("yahootoolbarSearchTextDyn");
    
    return dynBox;
}
CompanionDisplayer.prototype.saveOldSearchTerms = function(newBox, oldName)
{
    var oldMenuList = document.getElementById(oldName);
    if(oldMenuList != null)
    {
        //alert("Cloning old search terms.");
        var tmp = oldMenuList.childNodes;
        for(var n=0; n < tmp.length; n++)
        {
            //alert("Added term from " + tmp[n]);
            //newBox.insertItemAt(n, tmp[n]);
            newBox.appendChild(tmp[n]);
        }
        
        // Now copy the "hidden" attribute
        newBox.hidden = oldMenuList.hidden;
    }
    
}
CompanionDisplayer.prototype.buildButtonMenu = function(bm)
{
    var dynBm = null;
    dynBm = document.createElement("toolbarbutton");
    var myid = "dynmenubutton" + this.itemIdx;
    this.itemIdx++;
    dynBm.setAttribute("id", myid);
    dynBm.setAttribute("class","yahoobuttonmenu");
    dynBm.setAttribute("type","menu-button");
    dynBm.setAttribute("tooltiptext", bm.getTooltip());
    
    // since these are MENU-BUTTONs, we need to make sure that
    // the target of the click event is the button, otherwise
    // a click on any item in the menu will be handled first by
    // that item, then by the button. Hence the "if(event.target..."
    if(bm.isSearch())
    {
        var act = "if(event.target == this) { yahootoolbar.dynSearch('"+bm.getLink()+"'); }";
        dynBm.setAttribute("oncommand",act);
    }
    else
    {
        var link = bm.getLink();
        var act = "if(event.target == this) { yahootoolbar.LoadPage('"+link+"',event.ctrlKey); }";
        dynBm.setAttribute("oncommand",act);
        
        act = "if(event.target == this) { yahootoolbar.onClick(event); }";
        dynBm.link = link;
        dynBm.setAttribute("onclick",act);
	        
    }

    // first set the "button" parts
	// might wanna put support for other languages here at some point
	if (this.UseIconsAndNames || bm.getImage() == "")
	    dynBm.setAttribute("label", bm.getTitle());
    dynBm.setAttribute("image", this.imgMap.getUrl(bm.getImage()));

    // now set the menu parts.
    dynBm.appendChild(this.buildMenuPopup(bm.getItems(), bm.isSearch()));
    return dynBm;
}
CompanionDisplayer.prototype.buildMenu = function(menu, nestedMenu)
{
    var dynMenu = null;

	// cjh - there's a better way... scroll down
    // some menu's are shown, like Alerts when there are no items.
    //if(! menu.isDisplayable())
    //    return null;

    // we need a different style class for nested menus
    if (nestedMenu) {
        dynMenu = document.createElement("menu");
        dynMenu.setAttribute("class","yahoonestedbuttonmenu");
        dynMenu.setAttribute("label", menu.getTitle());
        dynMenu.setAttribute("tooltiptext", menu.getTooltip());
    } else {
        dynMenu = document.createElement("toolbarbutton");
        dynMenu.setAttribute("class","yahoobuttonmenu");
        if (this.UseIconsAndNames)
            dynMenu.setAttribute("label", menu.getTitle());
        dynMenu.setAttribute("tooltiptext", menu.getTooltip());
    }
    dynMenu.setAttribute("image", this.imgMap.getUrl(menu.getImage()));
    dynMenu.setAttribute("type","menu");


    // first we make the menu item itself
    var myid = "dynmenu" + this.itemIdx;
    this.itemIdx++;
    dynMenu.setAttribute("id", myid);

	// If there are no alert items, create the menu button
	// but don't display it.
    if(menu.getType() == "alert")
    {
		this.AlertButtonId = myid;

        if(menu.items.length == 0)
        {
		dynMenu.setAttribute("style","display:none;");
	}
    }

    // now build the items inside the menu
    dynMenu.appendChild(this.buildMenuPopup(menu.getItems()));

    // mark the yahoo bookmarks menu to add to the yahoo toolbar
    if (menu.getTitle() == this.preferences.quickLaunchFolder) {
        dynMenu.setAttribute("id", "yahooToolbarLaunch");
    }

    return dynMenu;
}

CompanionDisplayer.prototype.buildMenuPopup = function(items, isSearch)
{
    var myStrings = document.getElementById("yahootoolbar_strings");
    
    if(isSearch == null)
        isSearch = false;
    var popup = document.createElement("menupopup");
    for( var i = 0; i < items.length ; i++)
    {
        var mli = items[i];
        var dynMli = null;
        if(mli.constructor == MenuItem)
        {
            // build a menu item
            dynMli = this.buildMenuItem(mli, isSearch);
        }
        else
        {
            // this is a nested menu!
            dynMli = this.buildMenu(mli, true);
        }
	if (dynMli) 
	{
		popup.appendChild(dynMli);
        
        	if (dynMli.id == "addBM")
        		popup.id = "yahooToolbarBookmarks";
	}
        	
    }
    if (i > 0 && items[0].isAddBookmark && items[0].isAddBookmark() ) {        // If this is a bookmark menu
        dynMli = document.createElement("menuitem");
        var txt = myStrings.getString("addInTabs");
        dynMli.setAttribute("label",txt);
        dynMli.setAttribute("tooltiptext",txt);
        dynMli.setAttribute("onclick","return yahootoolbar.OpenTabs(event)");
        popup.appendChild(document.createElement("menuseparator"));
        popup.appendChild(dynMli);
        
    }
    
    return popup;
}
CompanionDisplayer.prototype.buildMenuItem = function(mi, isSearch)
{
    var dynMi = null;
    var myid = "dynmenuitem" + this.itemIdx;
    this.itemIdx++;
    
    if(mi.isSeparator())
    {
        dynMi = document.createElement("menuseparator");
    }    
    else if(mi.isHighlight())
    {
        return null;
    }
    else
    {
        dynMi = document.createElement("menuitem");
        dynMi.setAttribute("label", mi.getTitle());
        dynMi.setAttribute("tooltiptext", mi.getToolTip());
        if(mi.isRefresh())
        {
            dynMi.setAttribute("oncommand","yahootoolbar.dynOpen();");
        }
        else if(mi.isActionItem())
        {
       	    var link = mi.getLink();
	    if(link != null)
	    {
	        dynMi.link = link;
	        dynMi.setAttribute("onclick","return yahootoolbar.onClick(event)");
	        dynMi.setAttribute("oncommand", "return yahootoolbar.onCmd(event);");
	        dynMi.setAttribute("tooltiptext", link);
	    }
        }
        else if(mi.isPopup())
        {
            var link = mi.getLink();
	    if(link != null)
	    {
	        var act = "";
	        act = "window.open("+link+"); return true;";
		dynMi.setAttribute("oncommand",act);
	    }
        }
        else if(mi.isUninstall())
        {
            // Add uninstall here!
            dynMi.setAttribute("oncommand","yahootoolbar.Uninstall();");
        }
	else if(mi.isAbout())
	{
            dynMi.setAttribute("oncommand","yahootoolbar.showAbout();");
	}
        else if(mi.isAddBookmark())
        {
            var link = mi.getLink();
            myid = "addBM" + link;
            
	    dynMi.folder = link;
            dynMi.setAttribute("oncommand","yahootoolbar.AddBookmark(event); return true;") ;

        }
	else if(mi.isIconOnlyToggle())
	{
            var link = mi.getLink();
            if(link != null)
            {
	        // cjh: need to fix some stuff before enabling this
	        //setTimeout("yahootoolbar.dynOpen()",60000);
				
                var act = "";
                if(isSearch)
                    act = "yahootoolbar.dynSearch('"+mi.getLink()+"'); return true;";
                else
                    act = "yahootoolbar.LoadPage('"+mi.getLink()+"'); return true;";
                
		dynMi.setAttribute("oncommand",act);
            }
	}
	else if (mi.isSwitch() )
	{
		act = "yahootoolbar.preferences.feed="+ mi.getLink();
		act += "; yahootoolbar.dynOpen();" ;

		dynMi.setAttribute("oncommand",act);
	}
	else if (mi.menutype == 0) 
	{
		dynMi.setAttribute("class","menuitem-iconic");
		dynMi.setAttribute("image","chrome://yahootoolbar/content/icons/ylogo.gif");
	}
        else
        {
            var link = mi.getLink();
            if(link != null)
            {
                var act = "";
                if(isSearch)
                    act = "yahootoolbar.dynSearch('"+mi.getLink()+"'); return true;";
                    //alert('search for ' + mi.getTitle());
                else
                    act = "yahootoolbar.LoadPage('"+mi.getLink()+"'); return true;";
                
		dynMi.setAttribute("oncommand",act);
            }
            //else
            //    alert("HEY: mi: " + mi.getTitle() + " has no link!");
        }
	if (mi.image)
	{
	    dynMi.setAttribute("class","menuitem-iconic");
	    dynMi.setAttribute("image",this.imgMap.getUrl(mi.image));
	}
    }
    
    dynMi.setAttribute("id", myid);
    return dynMi;
}


CompanionDisplayer.prototype.buildButton = function(but)
{
    // We do not support the Highlight function, so we suppress it
    if (but.type == "srch_hi.bmp") 
	return null;

    // buildButton sometimes returns a separator...
    // the companion feed considers a Separator a button...
    if(but.isSeparator())
    {
        // ok... we need to build a separator, not a button.
        var sep = document.createElement("toolbarseparator");
        var myid  = "dynsep"+this.itemIdx;
        this.itemIdx++;
        sep.setAttribute("id",myid);
        return sep;
    }
    else
    {
        var button = document.createElement("toolbarbutton");
        button.setAttribute("class", "yahoobutton");
        var myid = "dynbutton"+this.itemIdx;
        this.itemIdx++;
        button.setAttribute("id",myid);
        if(but.isSearchToggle())
        {
	    button.setAttribute("label",but.getTitle());
            button.setAttribute("image",this.imgMap.getUrl(but.getImage()));
            var act = "var sb = document.getElementById('yahootoolbarSearchTextDyn'); if(sb.getAttribute('hidden') == 'true'){sb.setAttribute('hidden','');} else {sb.setAttribute('hidden','true');} "
            button.setAttribute("oncommand",act);
        }
        else
        {
            if (this.UseIconsAndNames)
                button.setAttribute("label", but.getTitle());
            button.setAttribute("tooltiptext", but.getTitle());
            button.setAttribute("image",this.imgMap.getUrl(but.getImage()));
            
            var link = but.getLink();
            var act = "yahootoolbar.LoadPage('"+link+"',event.ctrlKey)";
            button.setAttribute("oncommand",act);
            
            act = "yahootoolbar.onClick(event);";
	    button.link = link;
	    button.setAttribute("onclick",act);
	
        }
        return button;
    }
}

// returns the offline label
// XXX: this could be made more generic for any label
CompanionDisplayer.prototype.buildLabel = function(label)
{
    var label = document.createElement("label");
    label.setAttribute("value", "...attempting to retrieve buttons from Yahoo!...");
    return label;
}
